Subject: RE: A question about RFC2960.

From: [email-masked]
Date: Fri, 5 Sep 2003 14:48:46 +0800

Hi,

Thank you for your response.

And I reply to you in the following context.

Brs,
Wei Fusheng

-----Original Message-----
From: ext Brian F. G. Bidulock [mailto:[email-masked]]
Sent: 2003Äê9ÔÂ5ÈÕ 12:57
To: Wei Fusheng (NRC/Beijing)
Cc: [email-masked]; Ovaska Petri (NET/Helsinki); Timperi
Juha-Pekka (NET/Helsinki); Che Xiangguang (NRC/Beijing); Huang Hui
(NRC/Beijing); Zhang Dongmei (NRC/Beijing); Zhang Dajiang (NRC/Beijing)
Subject: Re: A question about RFC2960.

Fusheng.Wei,

On Fri, 05 Sep 2003, [email-masked] wrote:

>> 
>>    Hi,
>> 
>> 
>> 
>>    I have a question about RFC2960. Could you help me?
>> 
>> 
>> 
>>    In  the section "6.3.3 Handle T3-rtx Expiration" of RFC2960, there are
>>    the following words:
>> 
>> 
>> 
>>       Note: Any DATA chunks that were sent to the address for which the
>>       T3-rtx timer expired but did not fit in one MTU (rule E3 above),
>>       should be marked for retransmission and sent as soon as cwnd allows
>>       (normally when a SACK arrives).
>> 
>> 
>> 
>>    What's  the  meaning of "normally when a SACK arrives"? Must sctp obey
>>    this rule?

>Because in rule E1 you set cwnd <- MTU.  Becaue of this, for a single homed
>association, it will take a SACK to increase cwnd and any messages that would
>not fit in the retransmitted packet will normally have to wait for a SACK.

Re:
   I see. But sctp will send a second packet when we do the implementation. Because:
			flight_size < CWND
   So sctp can send more than one packets for a single homed association in fact.

>> 
>> 
>>    To my point of view, sctp should send packets as much as CWND allows.

>It does.  In this case, in the single-homed case, cwnd is 1 MTU.
Re: 
    See the words above.

>> 
>> 
>> 
>>    Because  this  rule  will block a path. And this rule will cause a big
>>    problem in multi-home situation.

>Quoted above is a note.  E1) is a rule.  cwnd <- MTU on T3-rtx expiry.  The
>path is only blocked if there was greater than 1 MTU of data to retransmit.
>This blocking is a natural consequence of congestion control.

>> 
>> 
>> 
>>    Suppose that we two pathes (path A and path B) between endpoint E1 and
>>    endpoint E2 in multi-home situation.
>> 
>> 
>> 
>>    If path A  was broken and T3-rtx timer expired, a retransmitted packet
>>    will  be  sent in path B and then path B will be blocked waiting for a
>>    SACK according to this rule.

>No it will not.  Rule E1 says you set cwnd <- MTU on path A.  This is very
>clear:
>
>   E1) For the destination address for which the timer expires, adjust
>       ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
>       its ssthresh with rules defined in Section 7.2.3 and set the cwnd
>       <- MTU.
>
>T3-rtx did not expire to destination B in your example and therefore it might
>very well have a cwnd > MTU and be allowed to send more data.  But as
>mentioned in the note, typically it will not.  This is because while A was
>used as the primary, B was not carrying traffic and its cwnd should have
>fallen to 1 MTU under normal conditions anyway.

RE:
    This the most important part!
    When T3-rtx timer of path A expired, the CWND of path A will be 1*MTU, 
    while the CWND of path B is still the initial value 2*MTU but not 1*MTU
    as you mentioned above.

    It is the main reason why I think this rule will affect the efficiency of SCTP.

>> 
>> 
>> 
>>    It means that no packets can be sent between E1 and E2 until a SACK is
>>    received or T3-rtx timer expires again.

>No it does not.  You read too much into a parenthesized comment.

>> 
>> 
>> 
>>    I  think  this  rule  will affect the efficiency of SCTP and we should
>>    remove this words.

>It is not a rule, it is a note.  It contains the RFC keywords "should", but
>only pertaining to sending the outstanding TSN as soon as possible given cwnd
>consideration which is reasonable.

>If anything, it says that you SHOULD send all the packets you can on B given
>its cwnd, which is what you want to do anyway, is it not?

RE: OK. Thank you.

>--brian

>>    What do you think?
>>    Brs,
>>    Wei Fusheng

>-- 
>Brian F. G. Bidulock    ¦ The reasonable man adapts himself to the ¦
>[email-masked]    ¦ world; the unreasonable one persists in  ¦
>http://www.openss7.org/ ¦ trying  to adapt the  world  to himself. ¦
>                        ¦ Therefore  all  progress  depends on the ¦
>                        ¦ unreasonable man. -- George Bernard Shaw ¦
>

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Fri, 5 Sep 2003 01:58:15 -0600

Fusheng.Wei,

>    So sctp can send more than one packets for a single homed association in fact.

See implementation guide section 2.7.

--brian